      program p_metr_ts ! Bernd Berg, Apr 19 2002. 
C Potts model Metropolis with random updating.
C MC prodcution run to create energy (action variable) time series.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      character cd*1,cq*2,cl*3
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension tsa(nmeas)
      include 'lat.dat'
      ltest=.true.
      ltest=.false.
      if(ltest) stop "ltest p_met_ts."
C
      write(iuo,'(/," p_metr_ts.f: nq =",I3)') nq
      lpr=.true.
      call potts_init(lpr) ! Initialize Potts Metropolis MC.
C
      do iequi=1,nequi     ! Sweeps for reaching equilibrium.
        call potts_met_r
      end do
      acpt=(acpt/nequi)/ms
      if(ltest) print*,"After equilibration: iact =",iact
C
      write(cd,'(I1.1)') nd
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      open(iud1,file="p"//cq//"_"//cd//"d"//cl//".D",
     &     form="unformatted",status="unknown")
      write(iud1) beta,nd,nq,nla,mlink,nequi,nrpt,nmeas,nsw
      do irpt=1,nrpt ! nrpt repetitions of nmeas measurement sweeps.
        call write_progress(iud2,"irpt,iact,acpt:",irpt,iact,acpt)
        acpt=zero
        do imeas=1,nmeas
          do isw=1,nsw
            call potts_met_r
          end do
          tsa(imeas)=(ONE*iact)/mlink ! Action per link.
        end do
        acpt=(acpt/nmeas)/ms
        write(iud1) ha,tsa,acpt,irpt
        print'(" irpt,iact,acpt:",2I10,1F10.2)',irpt,iact,acpt
      end do
      close(iud1)
C
      stop
      end

      include '../../Libs/Fortran_par/potts_init.f'
      include '../../Libs/Fortran_par/potts_met_r.f'

      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'

      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_order.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_wght.f'

      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmafun.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/write_progress.f'
